//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "About.h"
#include "SNotes.h"
#include "inifiles.hpp"
#include "ShellAPI.h"
#include "stdio.h"
//--------------------------------------------------------------------- 
#pragma resource "*.dfm"
TAboutBox *AboutBox;
AnsiString PrefFileAbout=ExtractFilePath(Application->ExeName)+"Preferences.ini";
//---------------------------------------------------------------------
__fastcall TAboutBox::TAboutBox(TComponent* AOwner)
	: TForm(AOwner)
{
}

void ApplyLangAbout();
//---------------------------------------------------------------------
 void __fastcall TAboutBox::HomePageLabelClick(TObject *Sender)
{
   if (SNotesXMForm->RussianLangMenu->Checked)
      ShellExecute(0, NULL, "http://www.snotes.narod.ru", NULL,NULL,1);
   else
      ShellExecute(0, NULL, "http://www.snotes.narod.ru/index_en.htm", NULL,NULL,1);
}
//---------------------------------------------------------------------------
void __fastcall TAboutBox::MailLabelClick(TObject *Sender)
{
   ShellExecute(0, NULL, "mailto:xelfium@mail.ru", NULL, NULL,1);
}
//---------------------------------------------------------------------------
void __fastcall TAboutBox::OKButtonClick(TObject *Sender)
{
   AboutBox->Close();
}
//---------------------------------------------------------------------------
void __fastcall TAboutBox::FormCreate(TObject *Sender)
{
   ApplyLangAbout();
}
//---------------------------------------------------------------------------
void ApplyLangAbout()
{
         TIniFile *LangIni;
         if (SNotesXMForm->RussianLangMenu->Checked)
            LangIni = new TIniFile (ExtractFilePath(Application->ExeName)+"Languages\\Russian.lng");
         if (SNotesXMForm->EnglishLangMenu->Checked)
            LangIni = new TIniFile (ExtractFilePath(Application->ExeName)+"Languages\\English.lng");
         if (SNotesXMForm->DutchLangMenu->Checked)
            LangIni = new TIniFile (ExtractFilePath(Application->ExeName)+"Languages\\Dutch.lng");
         try
            {
               AboutBox->Caption=LangIni->ReadString("Language", "ABOUT_WINDOW_TITLE", " ...");
               AboutBox->LogoCreationLabel->Caption="("+LangIni->ReadString("Language", "ABOUT_LOGO_LABEL", "c ")+")";
               if (SNotesXMForm->RussianLangMenu->Checked)
                  AboutBox->MainAuthorLabel->Caption=" , 2004-2008 (c)";
               else
                  AboutBox->MainAuthorLabel->Caption="Saprykin Alexander, 2004-2008 (c)";
               if (SNotesXMForm->RussianLangMenu->Checked)
                  AboutBox->LogoAuthorLabel->Caption=" ";
               else
                  AboutBox->LogoAuthorLabel->Caption="Karpov Sergei";
               AboutBox->DutchTranslationLabel->Caption="("+LangIni->ReadString("Language", "ABOUT_DUTCH_TRANSLATION_LABEL", "  ")+")";
               AboutBox->WarrantyLabel->Caption=LangIni->ReadString("Language", "ABOUT_WARRANTY_LABEL", "     freeware   .");
            }
         catch (...)
            {
               Application->MessageBoxA("Error reading language file. Default language will be used", "Error", MB_OK+MB_ICONERROR);
            }
         delete LangIni;
}
//---------------------------------------------------------------------------

void __fastcall TAboutBox::LogoMailLabelClick(TObject *Sender)
{
   ShellExecute(0, NULL, "mailto:AB0@list.ru", NULL,NULL,1);
}
//---------------------------------------------------------------------------

void __fastcall TAboutBox::DutchMailLabelClick(TObject *Sender)
{
   ShellExecute(0, NULL, "mailto:peter66smit@gmail.com", NULL,NULL,1);
}
//---------------------------------------------------------------------------

